Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/.directory
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/.directory	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/.directory	(revision 44198)
@@ -0,0 +1,7 @@
+[Dolphin]
+Timestamp=2019,3,14,15,18,44
+Version=4
+ViewMode=1
+
+[Settings]
+HiddenFilesShown=true
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/impl/JDBCSetProvider.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/impl/JDBCSetProvider.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/impl/JDBCSetProvider.java	(revision 44198)
@@ -133,12 +133,12 @@
     
     @Override
     public boolean canFilter() {
-        return this.getHelper().supportFilter(getQuery().getFilter());
+        return this.getHelper().supportFilter(this.getFeatureType(), getQuery().getFilter());
     }
 
     @Override
     public boolean canOrder() {
-        return this.getHelper().supportOrder(getQuery().getOrder());
+        return this.getHelper().supportOrder(this.getFeatureType(), getQuery().getOrder());
     }
     
     public ResulSetControler getResulSetControler() {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/JDBCHelper.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/JDBCHelper.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/JDBCHelper.java	(revision 44198)
@@ -8,6 +8,7 @@
 import org.gvsig.fmap.dal.exception.InitializeException;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureQueryOrder;
+import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.fmap.dal.feature.FeatureType;
 import org.gvsig.fmap.dal.feature.spi.FeatureProvider;
 import org.gvsig.fmap.dal.resource.exception.AccessResourceException;
@@ -93,9 +94,9 @@
      */
     public boolean hasSpatialFunctions();
 
-    public boolean supportFilter(Evaluator evaluator);
+    public boolean supportFilter(FeatureType type, Evaluator evaluator);
     
-    public boolean supportOrder(FeatureQueryOrder order);
+    public boolean supportOrder(FeatureType type, FeatureQueryOrder order);
     
     public boolean allowNestedOperations();
     /**
@@ -179,4 +180,5 @@
 
     public String getSourceId(JDBCStoreParameters parameters);
 
+    public boolean isThreadSafe();
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AbstractConnectionOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AbstractConnectionOperation.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AbstractConnectionOperation.java	(revision 44198)
@@ -39,7 +39,12 @@
     @Override
     public Object perform()  {
         try {
-            return this.perform_operation();
+            if( this.helper.isThreadSafe() ) {
+                return this.perform_operation();
+            } 
+            synchronized(AbstractConnectionOperation.class) {
+                return this.perform_operation();
+            }
         } catch (RuntimeException ex) {
             throw ex;
         } catch (Exception ex) {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/ResultSetForSetProviderOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/ResultSetForSetProviderOperation.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/ResultSetForSetProviderOperation.java	(revision 44198)
@@ -5,7 +5,8 @@
 import java.util.List;
 import org.apache.commons.lang3.ArrayUtils;
 import org.apache.commons.lang3.StringUtils;
-import org.gvsig.expressionevaluator.ExpressionBuilder.Config;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Variable;
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureQuery;
@@ -16,6 +17,8 @@
 import org.gvsig.fmap.dal.store.jdbc2.OperationsFactory.TableReference;
 import org.gvsig.fmap.dal.store.jdbc2.ResulSetControler.ResultSetEntry;
 import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_FEATURE_TYPE;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_TABLE;
 import org.gvsig.fmap.geom.DataTypes;
 import org.gvsig.tools.evaluator.Evaluator;
 
@@ -82,6 +85,7 @@
         
         double tolerance = -1 ; //query.getScale();
         JDBCSQLBuilderBase sqlbuilder = createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
         
         List<String> primaryKeys = new ArrayList<>();
         for(FeatureAttributeDescriptor attr : storeType.getPrimaryKey() ) {
@@ -101,16 +105,17 @@
                 forcedColumns.remove(attr.getName());
             }
             if( attr.getType() == DataTypes.GEOMETRY ) {
-                if( tolerance<=0 || !sqlbuilder.getConfig().has_functionality(Config.ST_Simplify)) {
-                    sqlbuilder.select().column().name(attr.getName()).as_geometry();
-                } else {
-                    sqlbuilder.select().column().value(
-                        sqlbuilder.ST_Simplify( 
-                            sqlbuilder.column(attr.getName()),
-                            sqlbuilder.constant(tolerance)
-                        )
-                    ).as_geometry();
-                }
+                sqlbuilder.select().column().name(attr.getName()).as_geometry();
+//                if( tolerance<=0 || !sqlbuilder.getConfig().has_functionality(Config.ST_Simplify)) {
+//                    sqlbuilder.select().column().name(attr.getName()).as_geometry();
+//                } else {
+//                    sqlbuilder.select().column().value(
+//                        sqlbuilder.ST_Simplify( 
+//                            sqlbuilder.column(attr.getName()),
+//                            sqlbuilder.constant(tolerance)
+//                        )
+//                    ).as_geometry();
+//                }
                 columns.add(attr);
             } else {
                 sqlbuilder.select().column().name(attr.getName());
@@ -132,11 +137,13 @@
         if( filter != null ) {
             String sqlfilter = filter.getSQL();
             if( ! StringUtils.isEmpty(sqlfilter) ) {
-                sqlbuilder.select().where().set( sqlbuilder.custom(sqlfilter) );
+                if( this.helper.supportFilter(this.storeType, filter) ) {
+                    sqlbuilder.select().where().set(expbuilder.toValue(sqlfilter));
+                }
             }
         }
         if( ! StringUtils.isEmpty(baseFilter) ) {
-            sqlbuilder.select().where().and(sqlbuilder.custom(baseFilter));
+            sqlbuilder.select().where().and(expbuilder.toValue(baseFilter));
         }
         
         FeatureQueryOrder order = query==null? null:query.getOrder();
@@ -170,7 +177,7 @@
             // obtener los primeros elementos sin importarnos su orden.
             for(String attrName : primaryKeys ) {
                 // Se precisa indicar un orden para usar OFFSET.
-                sqlbuilder.select().order_by().column(sqlbuilder.identifier(attrName)).ascending();
+                sqlbuilder.select().order_by().column(sqlbuilder.as_identifier(attrName)).ascending();
             }
         }        
         if( limit > 0 ) {
@@ -181,7 +188,11 @@
         if( offset>0 ) {
             sqlbuilder.select().offset(offset);
         }
-        
+        sqlbuilder.setProperties(
+                Variable.class, 
+                PROP_FEATURE_TYPE, this.storeType,
+                PROP_TABLE, table
+        );
         String sql = sqlbuilder.toString();
         ResultSetEntry resultSetEntry = this.helper.getResulSetControler().create(
                 sql, fetchSize, columns.toArray(new FeatureAttributeDescriptor[columns.size()])
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CountOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CountOperation.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CountOperation.java	(revision 44198)
@@ -5,12 +5,15 @@
 import java.sql.SQLException;
 import java.sql.Statement;
 import org.apache.commons.lang3.StringUtils;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
 import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase;
 import org.gvsig.fmap.dal.store.jdbc.exception.JDBCSQLException;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
 import org.gvsig.fmap.dal.store.jdbc2.OperationsFactory.TableReference;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_FEATURE_TYPE;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_TABLE;
 
 public class CountOperation extends AbstractConnectionOperation {
 
@@ -47,6 +50,7 @@
             String filter) throws DataException {
 
         JDBCSQLBuilderBase sqlbuilder = this.createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
 
         sqlbuilder.select().column().value(sqlbuilder.count().all());
         sqlbuilder.select().from().table()
@@ -55,13 +59,16 @@
                 .name(this.table.getTable());
         sqlbuilder.select().from().subquery(this.table.getSubquery());
         if (!StringUtils.isEmpty(baseFilter)) {
-            sqlbuilder.select().where().set( sqlbuilder.custom(baseFilter) );
+            sqlbuilder.select().where().set( expbuilder.custom(baseFilter) );
         }
         if (!StringUtils.isEmpty(filter)) {
             // El and() hace un set() si no hay un filtro previo
-            sqlbuilder.select().where().and(sqlbuilder.custom(filter));
+            sqlbuilder.select().where().and(expbuilder.custom(filter));
         }
-
+        sqlbuilder.setProperties(
+                ExpressionBuilder.Variable.class, 
+                PROP_TABLE, table
+        );
         String sql = sqlbuilder.select().toString();
 
         Statement st = null;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/FetchFeatureProviderByReferenceOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/FetchFeatureProviderByReferenceOperation.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/FetchFeatureProviderByReferenceOperation.java	(revision 44198)
@@ -7,6 +7,7 @@
 import java.sql.SQLException;
 import java.util.ArrayList;
 import java.util.List;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureType;
@@ -17,6 +18,8 @@
 import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
 import org.gvsig.fmap.dal.store.jdbc2.OperationsFactory.TableReference;
 import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_FEATURE_TYPE;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_TABLE;
 import org.gvsig.fmap.geom.DataTypes;
 
 
@@ -61,7 +64,8 @@
         String[] primaryKeys = reference.getKeyNames();
         
         JDBCSQLBuilderBase sqlbuilder = this.createSQLBuilder();
-        
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+
         for (FeatureAttributeDescriptor attr : featureType) {
             if( attr.getType()==DataTypes.GEOMETRY ) {
                 sqlbuilder.select().column().name(attr.getName()).as_geometry();
@@ -83,19 +87,23 @@
             Object value = reference.getKeyValue(name);
             if( value == null ) {
                 sqlbuilder.select().where().and(
-                    sqlbuilder.isNull(sqlbuilder.column(name))
+                    expbuilder.is_null(expbuilder.column(name))
                 );                
             } else {
                 sqlbuilder.select().where().and(
-                    sqlbuilder.eq(
-                        sqlbuilder.column(name), 
-                        sqlbuilder.parameter(name).value(value)
+                    expbuilder.eq(
+                        expbuilder.column(name), 
+                        expbuilder.parameter(name).value(value)
                     )
                 );              
             }
         }
         sqlbuilder.select().limit(1);
-
+        sqlbuilder.setProperties(
+                ExpressionBuilder.Variable.class, 
+                PROP_FEATURE_TYPE, featureType,
+                PROP_TABLE, table
+        );
         String sql = sqlbuilder.select().toString();
 
         PreparedStatement st = null;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CalculateEnvelopeOfColumnOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CalculateEnvelopeOfColumnOperation.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CalculateEnvelopeOfColumnOperation.java	(revision 44198)
@@ -6,12 +6,15 @@
 import java.sql.Statement;
 import org.apache.commons.lang3.StringUtils;
 import org.cresques.cts.IProjection;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Variable;
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.store.jdbc.exception.JDBCSQLException;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
 import org.gvsig.fmap.dal.store.jdbc2.OperationsFactory.TableReference;
 import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_TABLE;
 import org.gvsig.fmap.geom.Geometry;
 import org.gvsig.fmap.geom.primitive.Envelope;
 
@@ -70,10 +73,12 @@
         // https://alastaira.wordpress.com/2011/07/26/determining-the-geographic-extent-of-spatial-features-in-a-sql-server-table/
         //
         JDBCSQLBuilderBase sqlbuilder = this.createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+        
         sqlbuilder.select().column().value(
-            sqlbuilder.getAsGeometry(
-                sqlbuilder.ST_ExtentAggregate(
-                        sqlbuilder.column(columnName)
+            expbuilder.as_geometry(
+                expbuilder.ST_ExtentAggregate(
+                        expbuilder.column(columnName)
                 )
             )
         );
@@ -87,32 +92,35 @@
         if (StringUtils.isEmpty(baseFilter)) {
             if (limit != null) {
                 sqlbuilder.select().where().set(
-                        sqlbuilder.ST_Intersects(
-                                sqlbuilder.ST_Envelope(
-                                        sqlbuilder.column(columnName)
+                        expbuilder.ST_Intersects(
+                                expbuilder.ST_Envelope(
+                                        expbuilder.column(columnName)
                                 ),
-                                sqlbuilder.ST_Envelope(
-                                        sqlbuilder.geometry(limit.getGeometry(), crs)
+                                expbuilder.ST_Envelope(
+                                        expbuilder.geometry(limit.getGeometry(), crs)
                                 )
                         )
                 );
             }
         } else {
-            sqlbuilder.select().where().set( sqlbuilder.custom(baseFilter) );
+            sqlbuilder.select().where().set( expbuilder.custom(baseFilter) );
             if (limit != null) {
                 sqlbuilder.select().where().and(
-                        sqlbuilder.ST_Intersects(
-                            sqlbuilder.ST_Envelope(
-                                    sqlbuilder.column(columnName)
+                        expbuilder.ST_Intersects(
+                            expbuilder.ST_Envelope(
+                                    expbuilder.column(columnName)
                             ),
-                            sqlbuilder.ST_Envelope(
-                                    sqlbuilder.geometry(limit.getGeometry(), crs)
+                            expbuilder.ST_Envelope(
+                                    expbuilder.geometry(limit.getGeometry(), crs)
                             )
                         )
                 );
             }
         }
-
+        sqlbuilder.setProperties(
+                Variable.class, 
+                PROP_TABLE, table
+        );
         String sql = sqlbuilder.select().toString();
 
         Statement st = null;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/TableIsEmptyOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/TableIsEmptyOperation.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/TableIsEmptyOperation.java	(revision 44198)
@@ -5,12 +5,15 @@
 import java.sql.SQLException;
 import java.sql.Statement;
 import org.apache.commons.lang3.StringUtils;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
 import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase;
 import org.gvsig.fmap.dal.store.jdbc.exception.JDBCSQLException;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
 import org.gvsig.fmap.dal.store.jdbc2.OperationsFactory.TableReference;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_FEATURE_TYPE;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_TABLE;
 
 public class TableIsEmptyOperation extends AbstractConnectionOperation {
 
@@ -48,7 +51,8 @@
         ) throws DataException {
 
         JDBCSQLBuilderBase sqlbuilder = this.createSQLBuilder();
-
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+        
         sqlbuilder.select().column().all();
         sqlbuilder.select().from().table()
                 .database(this.table.getDatabase())
@@ -56,14 +60,17 @@
                 .name(this.table.getTable());
         sqlbuilder.select().from().subquery(this.table.getSubquery());
         if (!StringUtils.isEmpty(baseFilter)) {
-            sqlbuilder.select().where().set( sqlbuilder.custom(baseFilter) );
+            sqlbuilder.select().where().set( expbuilder.custom(baseFilter) );
         }
         if (!StringUtils.isEmpty(filter)) {
             // El and() hace un set() si no hay un filtro previo
-            sqlbuilder.select().where().and(sqlbuilder.custom(filter));
+            sqlbuilder.select().where().and(expbuilder.custom(filter));
         }
         sqlbuilder.select().limit(1);
-        
+        sqlbuilder.setProperties(
+                ExpressionBuilder.Variable.class, 
+                PROP_TABLE, table
+        );
         String sql = sqlbuilder.select().toString();
 
         Statement st = null;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/PerformChangesOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/PerformChangesOperation.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/PerformChangesOperation.java	(revision 44198)
@@ -9,6 +9,8 @@
 import java.util.List;
 import org.apache.commons.collections.CollectionUtils;
 import org.apache.commons.lang3.StringUtils;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Variable;
 import org.gvsig.fmap.dal.DataTypes;
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
@@ -24,6 +26,8 @@
 import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
 import org.gvsig.fmap.dal.store.jdbc2.OperationsFactory.TableReference;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_FEATURE_TYPE;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_TABLE;
 import org.gvsig.tools.dispose.Disposable;
 import org.gvsig.tools.dispose.DisposeUtils;
 
@@ -88,6 +92,8 @@
             FeatureType type
         ) {
         JDBCSQLBuilderBase sqlbuilder = createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
+
         sqlbuilder.delete().table()
                 .database(this.table.getDatabase())
                 .schema(this.table.getSchema())
@@ -95,9 +101,9 @@
         for (FeatureAttributeDescriptor attr : type) {
             if (attr.isPrimaryKey()) {
                 sqlbuilder.delete().where().and(
-                        sqlbuilder.eq(
-                                sqlbuilder.column(attr.getName()),
-                                sqlbuilder.parameter(attr.getName()).as_variable()
+                        expbuilder.eq(
+                                expbuilder.column(attr.getName()),
+                                expbuilder.parameter(attr.getName()).as_variable()
                         )
                 );
             }
@@ -117,6 +123,10 @@
 
         PreparedStatement st = null;
         Disposable paramsDisposer = null;
+        sqlbuilder.setProperties(
+                Variable.class, 
+                PROP_TABLE, table
+        );
         String sql = sqlbuilder.delete().toString();
         try {
             st = conn.prepareStatement(sql);
@@ -149,6 +159,7 @@
             FeatureType type
         ) {
         JDBCSQLBuilderBase sqlbuilder = createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
 
         sqlbuilder.insert().table()
                 .database(this.table.getDatabase())
@@ -160,13 +171,15 @@
             }
             if (attr.getType() == DataTypes.GEOMETRY) {
                 sqlbuilder.insert().column().name(attr.getName()).with_value(
-                    sqlbuilder.parameter(attr.getName()).as_geometry_variable().srs(
-                        sqlbuilder.parameter().value(attr.getSRS()).as_constant()
-                    )
+                    expbuilder.parameter(attr.getName()).as_geometry_variable()
+                        .srs(
+                            expbuilder.parameter().value(
+                                attr.getSRS()).as_constant()
+                        )
                 );
             } else {
                 sqlbuilder.insert().column().name(attr.getName()).with_value(
-                        sqlbuilder.parameter(attr.getName())
+                        expbuilder.parameter(attr.getName())
                 );
             }
         }
@@ -181,6 +194,11 @@
 
         PreparedStatement st;
         Disposable paramsDisposer;
+        sqlbuilder.setProperties(
+                Variable.class, 
+                PROP_FEATURE_TYPE, type,
+                PROP_TABLE, table
+        );
         String sql = sqlbuilder.insert().toString();
         try {
             st = conn.prepareStatement(sql);
@@ -210,6 +228,7 @@
             FeatureType type
         ) {
         JDBCSQLBuilderBase sqlbuilder = createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
 
         sqlbuilder.update().table()
                 .database(this.table.getDatabase())
@@ -218,21 +237,21 @@
         for (FeatureAttributeDescriptor attr : type) {
             if (attr.isPrimaryKey()) {
                 sqlbuilder.update().where().and(
-                        sqlbuilder.eq(
-                                sqlbuilder.column(attr.getName()),
-                                sqlbuilder.parameter(attr.getName()).as_variable()
+                        expbuilder.eq(
+                                expbuilder.column(attr.getName()),
+                                expbuilder.parameter(attr.getName()).as_variable()
                         )
                 );
             } if ( ! attr.isAutomatic() &&  !attr.isReadOnly() ) {
                 if (attr.getType() == DataTypes.GEOMETRY) {
                     sqlbuilder.update().column().name(attr.getName()).with_value(
-                        sqlbuilder.parameter(attr.getName()).as_geometry_variable().srs(
-                            sqlbuilder.parameter().value(attr.getSRS()).as_constant()
+                        expbuilder.parameter(attr.getName()).as_geometry_variable().srs(
+                            expbuilder.parameter().value(attr.getSRS()).as_constant()
                         )
                     );
                 } else {
                     sqlbuilder.update().column().name(attr.getName()).with_value(
-                        sqlbuilder.parameter(attr.getName()).as_variable()
+                        expbuilder.parameter(attr.getName()).as_variable()
                     );
                 }
             }
@@ -252,6 +271,11 @@
         
         PreparedStatement st = null;
         Disposable paramsDisposer = null;
+        sqlbuilder.setProperties(
+                Variable.class, 
+                PROP_FEATURE_TYPE, type,
+                PROP_TABLE, table
+        );
         String sql = sqlbuilder.update().toString();
         try {
             st = conn.prepareStatement(sql);
@@ -347,6 +371,10 @@
                 }
             }
         }
+        sqlbuilder.setProperties(
+                Variable.class, 
+                PROP_TABLE, table
+        );
         return sqlbuilder.alter_table().toStrings();
     }
     
@@ -421,6 +449,10 @@
                     .database(this.table.getDatabase())
                     .schema(this.table.getSchema())
                     .name(this.table.getTable());
+                sqlbuilder.setProperties(
+                        Variable.class, 
+                        PROP_TABLE, table
+                );
                 sqls.addAll(sqlbuilder.create_index().toStrings());
             }
         }
